# Rust SSB Client

Write a simple SSB client in rust.
Properly plan before starting coding.
Program layout, UI design, changelog, etc.

#dev-diaries #ssb-show-and-tell #rust

## Goals
- Full protocol support
- Native linux application
- Lightweight
- Easy & simple to use
- Dark crystal support
- Possibly git-ssb & ssb chess support
- Built-in server, as well as support for external servers
- Simple tor support 
- Use modern & updated ssb standards
- Built in DAT image viewer
- Drafts
- Bookmarks

## Tools
### Software
- [golgi](http://golgi.mycelial.technology/) as main library
- [rust-gtk](https://gtk-rs.org)
- [relm-rs](https://github.com/antoyo/relm)
- [go-ssb](https://github.com/cryptoscope/ssb) as server? Maybe just for testing
- [Sunrise Choir](https://sunrisechoir.com/) libraries
- [clap](https://clap.rs/)
- https://github.com/datrs/hypercore-protocol-rs
- https://dbus.pages.freedesktop.org/zbus/

### Documentation
- [golgi docs](https://docs.rs/golgi/0.1.0/golgi/)
- [SSB golgi guide](https://dev.scuttlebutt.nz/#/rust/golgi)
- [Scuttlebutt Guide](https://github.com/ssbc/scuttlebutt-guide) lot's of links to other resources
- [Handbook](https://handbook.scuttlebutt.nz)
- [dark crystal docs](https://darkcrystal.pw)
- [Scuttlebot Docs](https://scuttlebot.io/)
- [Protocol Guide](https://ssbc.github.io/scuttlebutt-protocol-guide/)
- [GNOME Human Interface Guidelines](https://developer.gnome.org/hig)
